%Example Matlab Program to Connect to Viewport Interface
%Tested on Matlab Version is 7.8.0 2009a x64
%Make sure ReadADC.spin is loaded and running inside Viewport before
%running

NET.addAssembly('C:\propeller\dde\dotNetDll\vpClient.dll') %Open the Propeller Viewport DLL

vpObj=vpClient.Main(); %create the viewport .Net object
vpMsg=vpObj.connect;  %connect to the VP server, vpMsg holds any messages
vpMsg=char(vpMsg); %We always need to convert from .Net datatypes to Matlab types
if strcmp(vpMsg,'Connected to server')
    vpMsg=vpObj.requestString('list'); %get a list of variables in Viewport memory
    disp(char(vpMsg));
    
    x=vpObj.request('marray',12); %get the data from Viewport
    x=double(x); %convert from .Net object to Matlab array of doubles

    %plot our results
    figure, subplot(2,1,1)
    plot(x);
    title('Sample vs t')
    xlabel('Index (t)')
    ylabel('Sample Value')

    subplot(2,1,2)
    plot(abs(fft(x)));
    title('Magnitude of FFT vs Freq');
    xlabel('Freq');
    ylabel('Abs(fft(x))');
else 
    disp('Error: Cannot connect to Viewport');
end

vpMsg=vpObj.disconnect; %disconnect Viewport connection