{********************************************************
* (C) 2009 myDanceBot.com, Inc.                         *
* Shares the DemoBoard's Microphone value with ViewPort *
* AppletImage=time.gif                                  * 
*********************************************************
This program shares the DemoBoard's ADC's measurement of the
microphone with ViewPort.  The "bias" variable is shared as a
control channel- you can change it from ViewPort to adjust the
bias.  The "marray" channel is an array that contains 200 samples.
This code is used with the MatlabClient.
}
CON
 _clkmode        = xtal1 + pll16x
 _clkfreq        = 80_000_000
 bits=8
 samples=200
 samplePSec=10_000
OBJ
 vp    :       "Conduit"  'transfers data to/from PC
pub run|marray[samples/4],mic,bias,n,delay,nxt
  vp.config(string("var:marray,mic,bias"))
  vp.array(@marray,samples/4,5)
  vp.share(@mic,@mic)              'share the "mic" variable as a data channel
  biasp:=@bias                     'the bias variable can be "changed" from ViewPort- it's subtracted from the reading
  cognew(@sampleMIC, @mic)         'sample MIC from PIN 8
  delay:=clkfreq/samplePSec
  repeat
    vp.waitpacket                  'wait for a packet before sampling
    nxt:=cnt+delay    
    repeat n from 0 to samples-1
      byte[@marray][n]:=mic
      waitcnt(cnt+delay)
dat 'adapted from Chip's "microphone_to_headphones"
              org
sampleMic     mov       dira,asm_dira                   'make pins 8 (ADC) and 0 (DAC) outputs
              movs      ctra,#8                         'POS W/FEEDBACK mode for CTRA
              movd      ctra,#9
              movi      ctra,#%01001_000
              mov       frqa,#1
              mov       asm_cnt,cnt                     'prepare for WAITCNT loop
              add       asm_cnt,asm_cycles
:loop         waitcnt   asm_cnt,asm_cycles              'wait for next CNT value (timing is determinant after WAITCNT)
              mov       asm_sample,phsa                 'capture PHSA and get difference
              sub       asm_sample,asm_old
              rdlong    bias_,biasp
              add       asm_old,asm_sample
              sub       asm_sample,bias_
              wrlong    asm_sample,par                  'write to main memory
              jmp       #:loop                          'wait for next sample period
asm_cycles    long      |< bits - 1                     'sample time
asm_dira      long      $00000E00                       'output mask
biasp         long      0
bias_         long      573
asm_cnt       res       1
asm_old       res       1
asm_sample    res       1                                                                                                    