﻿/* Sample C# ViewPort Client v0.5
 * http://mydancebot.com
 * When the button is pressed, an advise loop is created for a 10 element array.
 * All 10 elements should be equal.
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using vpClient;

namespace csharp_client
{
    public partial class Form1 : Form
    {
        vpClient.Main vp;
        private delegate void doUIThread(string s);
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            vp = new vpClient.Main();
            vp.connect();
            int array1int = vp.requestInts("array1")[0];
            string array1str = vp.requestString("array1");
            vp.advise += new Main.adviseEventHandler(vp_advise);
            vp.startAdvise("array1", 12);
        }
        private void vp_advise(byte[] s, int format)
        {
            int v0,vn, n;
            
            v0= BitConverter.ToInt32(s, 0);
            string result;
            result = string.Format("{0}", v0);
            for (n = 1; n < 10; n++)
            {
                vn = BitConverter.ToInt32(s, n*4);
                result+= string.Format("{0}{1}",Environment.NewLine , vn);    
                if (vn!=v0) {                    
                    throw new Exception("Mismatch!");
                }
            }

            this.Invoke(new doUIThread(this.setTextbox), result);
        }
        private void setTextbox(string s)
        {
            textBox1.Text = s;
        }
    }

}
