﻿Imports System.Text
Imports NDde.Client

Public Class Main
    Private WithEvents client As DdeClient
    Event advise(ByVal s As Byte(), ByVal format As Integer)
    Event disconnected()
    Private lastStatus As String
    Public timeout As Integer = 1000
    Public Sub New()
        client = New DdeClient("vp", "system")
    End Sub

    Public Function execute(ByVal command As String) As String
        Try
            client.Execute(command, timeout)
            Return "Sent command to server"
        Catch ex As Exception
            Return "!" & ex.Message
        End Try
    End Function
    Public Function getlastStatus() As String
        Return lastStatus
    End Function
    Public Function request(ByVal item As String, ByVal format As Integer) As Byte()
        Try
            lastStatus = "Request succeeded"
            Return client.Request(item, format, timeout)
        Catch ex As exception
            lastStatus = "!" & ex.message
        End Try
        Return Nothing
    End Function

    Public Function requestInts(ByVal item As String) As Integer()
        Try
            lastStatus = "Request succeeded"
            Dim b() As Byte = client.Request(item, 12, timeout)
            Dim i(ubound(b) \ 4) As Integer
            System.Buffer.BlockCopy(b, 0, i, 0, UBound(b))
            Return i
        Catch ex As exception
            lastStatus = "!" & ex.message
        End Try
        Return Nothing
    End Function
    Public Function requestString(ByVal item As String) As String
        Try
            Dim b() As Byte = Nothing
            b = client.Request(item, 1, timeout)
            Return decode(b, 1)
        Catch ex As Exception
            Return "!" & ex.Message
        End Try
    End Function
    Public Function decode(ByVal b As Byte(), ByVal format As Integer) As String
        If b Is Nothing Then Return ""
        Dim result As String = "Illegal format:" + format.ToString
        Select Case format
            Case 1, 11
                Dim enc As New System.Text.ASCIIEncoding()
                result = enc.GetString(b)
            Case 12
                Dim n As Integer
                result = "$"
                For n = 0 To Math.Min(20, b.Length - 1)
                    result += String.Format("{0:X2} ", b(n))
                Next
                If n < b.Length Then result += String.Format("..Length={0} bytes", b.Length)
        End Select
        Return result
    End Function
    Public Function poke(ByVal item As String, ByVal value As String) As String
        Try
            client.Poke(item, value, timeout)
            Return "Poked data to server"
        Catch ex As Exception
            Return "!" & ex.Message
        End Try
    End Function

    Public Function startAdvise(ByVal item As String, ByVal format As Integer) As String
        Try
            client.StartAdvise(item, format, True, timeout)
            Return "Started advise loop"
        Catch ex As Exception
            Return "!" & ex.Message
        End Try
    End Function
    Public Function stopAdvise(ByVal item As String, ByVal format As Integer) As String
        Try
            client.StopAdvise(item, timeout)
            Return "Stopped advise loop"
        Catch ex As Exception
            Return "!" & ex.Message
        End Try
    End Function

    Public Sub client_Advise(ByVal sender As Object, ByVal e As NDde.Client.DdeAdviseEventArgs) Handles client.Advise
        RaiseEvent advise(e.Data, e.Format)
    End Sub
    Private Sub client_Disconnected(ByVal sender As Object, ByVal e As NDde.Client.DdeDisconnectedEventArgs) Handles client.Disconnected
        RaiseEvent disconnected()
    End Sub

    Public Function connect() As String
        Try
            client.Connect()
            Return "Connected to server"
        Catch ex As Exception
            Return "!" & ex.Message
        End Try
    End Function
    Public Function disconnect() As String
        Try
            If client.IsConnected Then client.Disconnect() : Return "Disconnected from server"
            Return "Wasn't connected"
        Catch ex As Exception
            Return "!" & ex.Message
        End Try
    End Function
End Class
