﻿'vpClient Sample Application
'August 2009 v0.5 mydancebot.com 
'This program demonstrates how to use the vpclient dll to interface with the ViewPort library.  
'Your program needs to include the "vpclient.dll" as a reference.
'This program maps each vpclient function to a button to allow you to try out the full functionality.
'
'You typically start and stop each session by calling "connect" and "disconnect".
'During a session use: "execute" to perform commands- like telling ViewPort to load a spin file.
'                 Use "request" to retrieve data from ViewPort- like the value of a Spin variable or array.
'                 Use "poke" to send data to ViewPort, for example- changing a Spin variable to a new number.
'                 Use "startAdvise" to start an advise loop, the "advise" event will fire with your requested data
'
'Each function returns with a status string.  If an error has occured, the status will start with an exclamation mark
'The "advise" and "request" functions require a "format".  Use 1 to get numbers, 11 to get numbers with units
'                                                          and 12 to get raw bytes.
'View the "mainform_load" function to see what commands you can use
Imports vpClient
Public Class MainForm
    Dim WithEvents vp As vpClient.Main
    Public Delegate Sub doUIThread(ByVal s As String) 'required because advise loop runs on different thread than textboxes were created on
    Private Sub connectB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles connectB.Click
        statusT.Text = vp.connect()
    End Sub
    Private Sub disconnectB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles disconnectB.Click
        statusT.Text = vp.disconnect()
    End Sub
    Private Sub executeB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles executeB.Click
        statusT.Text = vp.execute(executeC.Text)
    End Sub
    Private Sub requestB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles requestB.Click
        Dim format As Integer = Val(requestformat.Text)
        resultT.Text = vp.decode(vp.request(requestC.Text, format), format)
        statusT.Text = vp.getlaststatus
    End Sub
    Private Sub pokeB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pokeB.Click
        statusT.Text = vp.poke(pokeC.Text, pokeDataT.Text)
    End Sub
    Private Sub startAdviseB_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles startAdviseB.Click
        statusT.Text = vp.startAdvise(adviseC.Text, Val(AdviseFormatT.Text))
    End Sub
    Private Sub stopAdvise_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles stopAdvise.Click
        statusT.Text = vp.stopAdvise(adviseC.Text, Val(AdviseFormatT.Text))
    End Sub
    Private Sub doAdvise(ByVal b As Byte(), ByVal format As Integer) Handles vp.advise
        Invoke(New doUIThread(AddressOf setAdviseText), vp.decode(b, format))
    End Sub
    Private Sub setAdviseText(ByVal s As String)
        AdviseT.Text = s
    End Sub
    Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        vp = New vpClient.Main()
        Dim file As String = Application.StartupPath + "\..\..\..\sample.spin"
        executeC.Items.AddRange("connect disconnect".Split) 'connect/disconnect ViewPort to/from the Propeller
        executeC.Items.Add("link(n,myserver|get!n)")        'when the dde server's value changes, ViewPort variable "n" will change
        executeC.Items.AddRange("unlink unadvise".Split)    'clear all "links" or "advise" loops
        executeC.Items.Add("load(" + file + ")")            'compile and load the file to the Propeller and connect
        requestC.Items.Add("list")                          'lists all variables available to poke/request/advise
        requestC.Items.Add("detail(n)")                     'provides details on variable "n"
        requestC.Items.AddRange("n m n_m".Split)            'retrieves the value of 1 or more variable values
        requestC.Items.AddRange("$spacer $update".Split)    'use these special variables to set the spacer between variables, and the update rate in milliseconds
        pokeC.Items.AddRange("m n $spacer $update".Split)   'set the value of a single variable
        adviseC.Items.AddRange("n m n_m rise_n_5000_n_m".Split) 'rise_n_5000_n_m sets a trigger which returns the value of "n" and "m"
        'a trigger starts with "rise" or "fall" followed by the variable and the trigger value. Specify the result at the end   
        adviseC.SelectedIndex = 0
        executeC.SelectedIndex = 0
        requestC.SelectedIndex = 0
        pokeC.SelectedIndex = 0
    End Sub
End Class
